	ORG $FB00
init:
	XOR A
	OUT ($FE),A
	LD HL,$4000
	LD (HL),A
	LD DE,$4001
	LD BC,$1800
	LDIR		;cls
	LD (HL),$47
	LD C,$20
	LDIR		;set attr of top line
	LD HL,$0180	;column	(POKEd by BASIC loader)
	LD (xref),HL
	LD HL,$0040	;row (POKEd by BASIC loader)
	LD (yref),HL
	LD A,$05
	LD (planedir),A	;down and right

;now draw 8 power bars

	LD B,$08
	LD HL,$400A
init2:
	PUSH BC
	PUSH HL
	LD DE,UDG_base+$0010
	CALL drw3-$0002	;tap into draw plane routine
	POP HL
	POP BC
	INC HL
	DJNZ init2
	LD A,$04	;initial speed
	CALL skipspeeddown	;setup display and vars via this routine

gameloop:

	CALL delay1	;wait for 50Hz Vsync
	CALL clr_screen
	CALL draw_screen
	CALL check_keys
	CALL move_plane
;now check for Break key
	LD A,$7F
	IN A,($FE)
	RRA
	JP C,gameloop	;loop if SPACE not pressed
	LD A,$FE
	IN A,($FE)
	RRA
	JP C,gameloop	;SPACE but not CAPS pressed
	RET		;BREAK pressed so finish


check_keys:

;O and P = left/right
;Q and A = up/down
;W and S = inc/dec speed
;Y = fire (not used yet!)
;BREAK key check done in main loop

	LD A,$DF	;look for O+P
	IN A,($FE)
	LD C,A		;store in C
	LD B,$00	;initially no direction
	BIT 0,C		;going right using "P"
	JR NZ,keyl2
	LD A,B
	OR $01		;set right direction bit
	LD B,A
keyl2:
	BIT 1,C		;going left using "O"
	JR NZ,keyl3
	LD A,B
	OR $02		;set left direction bit
	AND $FE		;left overrides right!
	LD B,A
keyl3:
	LD A,$FD	;"A" key for down
	IN A,($FE)
	XOR $FF
	AND $01		
	JR Z,keyl4
	LD A,B
	OR $04		;set down direction bit
	LD B,A
keyl4:
	LD A,$FB	;"Q" key for up
	IN A,($FE)
	XOR $FF
	AND $01		
	JR Z,keyl5
	LD A,B
	OR $08		;set up direction bit
	AND $FB		;up overrides down!
	LD B,A
keyl5:
	BIT 4,C		;fire not implented yet!
	JR NZ,keyl6
	LD A,$04	;green border
	OUT ($FE),A	;as there's no concept of fire yet

keyl6:
	LD A,B
	CP $00
	JR Z,keyl7	;skip if no change
	LD (planedir),A
keyl7:
	LD A,$FB	;"W" key for speed up
	IN A,($FE)
	XOR $FF
	AND $02
	JR Z,keyl8
	LD A,(delay)
	DEC A
	CP $00		;change to FF for turbo mode!
	JR NZ,skipspeedup
	INC A
skipspeedup:
	LD (delay),A
	LD HL,powerbar_attr+$0009
	LD C,A
	LD B,$00
	SBC HL,BC
	LD C,$08
	LD DE,$580A
	LDIR

keyl8:
	LD A,$FD	;"S" key for speed down
	IN A,($FE)
	XOR $FF
	AND $02
	RET Z
	LD A,(delay)
	INC A
	CP $09		;speed 1-8
	JR NZ,skipspeeddown
	DEC A
skipspeeddown:
	LD (delay),A
	LD HL,powerbar_attr+$0009
	LD C,A
	LD B,$00
	AND A		;clear CF flag
	SBC HL,BC
	LD C,$08
	LD DE,$580A
	LDIR
	RET

move_plane:

;now move plane based on value inside planedir
;also check for hitting the edges of the map

	LD A,(planedir)
	LD B,A
	LD C,$00	;colour of border to use

;first check X plane

	LD HL,(xref)	;column
	BIT 0,B		;moving right?
	JR Z,notright
	INC HL		;if so then +1
notright:
	BIT 1,B
	JR Z,notleft
	DEC HL		;if left then -1

notleft:
	LD A,H
	OR L
	JR NZ,skipbounceleft
	LD L,$01
	LD C,$02
	LD A,(planedir)
	AND $FC		;lose left/right
	OR $01		;set right
	LD (planedir),A
skipbounceleft:
	LD A,H
	CP $06
	JR NZ,skipbounceright
	LD A,L
	CP $49
	JR NZ,skipbounceright
	LD HL,$0648	;hit right edge
	LD C,$02
	LD A,(planedir)
	AND $FC		;lose left/right
	OR $02		;set left
	LD (planedir),A
skipbounceright:
	LD (xref),HL

;now do Y plane

	LD HL,(yref)	;row
	BIT 2,B		;moving down?
	JR Z,notdown
	INC HL		;if so then +1
notdown:
	BIT 3,B
	JR Z,notup
	DEC HL		;if up then -1
	
notup:
	LD A,$FF
	CP H
	JR NZ,skipbounceup
	CP L
	JR NZ,skipbounceup
	LD HL,$0000
	LD C,$02
	LD A,(planedir)
	AND $F3		;lose up/down
	OR $04		;set down
	LD (planedir),A
skipbounceup:
	LD A,$04
	CP H
	JR NZ,skipbouncedown
	LD A,$6D
	CP L
	JR NZ,skipbouncedown
	LD HL,$046C	;max value is number of rows - number of visible lines (23)
			;eg: rows 0-99 gives a max of 100-23 = 77
	LD C,$02
	LD A,(planedir)
	AND $F3		;lose up/down
	OR $08		;set up
	LD (planedir),A
skipbouncedown:
	LD (yref),HL
	
;now set border colour

	LD A,C
	OUT ($FE),A
	RET


delay1:

;50Hz delay for smoothness using HALT instruction

	LD A,(delay)
	CP $00
	RET Z
	LD B,A
delay2:
	HALT
	DJNZ delay2
	RET


clr_screen:

;instead of blanking whole display file
;just blank any line that has a flashing attribute in it (ie: place name)

	LD HL,$5820	;start of attributes	(was 5800 but now skip the status bar at the top)
	LD C,$41	;equivalent address for pixel info (was 40 but now +1 because we're skipping top bar)
s0:
	LD B,$20	;32 attr bytes per line
s1:
	LD A,(HL)
	BIT 7,A		;flashing bit set?
	JR NZ,sflash	;if so then clear this line of display file
	INC HL
	DJNZ s1		;next column
snextline:
	INC C		;finished that line of attributes so go to next line of display file
			;yes I know display file would go $4000, 4020, 4040 etc.
			;but it's quicker to go $4000,$4100,$4200 and convert later!
	LD A,C
	CP $58		;last line of display file/start of attrs reached?
	JP NZ,s0	;loop back if not
	RET

sflash:
	PUSH HL		;preserve HL as parent routine uses it
	LD A,C		;display file line
	AND $F8		;work out which third we're in - that's still correct (40,48 or 50)
	LD H,A		;store in H
	LD A,C	
	AND $07		;now work out which line in the third we were in
	RRCA
	RRCA
	RRCA		;and multiply by 32 to get correct display file address

	LD L,A		;multiples of 32 will go in L
			;HL now correct

	XOR A
	LD B,$08	;8 display file lines per attr line
sf1:
	PUSH BC
	PUSH HL

	LD B,$20	;32 bytes per line
sf2:

	LD (HL),A	;empty display (A=0)
	INC HL
	DJNZ sf2

	POP HL
	INC H		;line below current one is +256 bytes away
	POP BC
	DJNZ sf1
	POP HL		;restore HL

	PUSH BC		;preserve BC
	LD BC,$0020	;we've wiped this line, so skip it
	ADD HL,BC	;by skipping the 32 bytes in the line
	POP BC
	LD A,L		;when we restored HL it can now be at any point on that line
	AND $E0		;ie: 0 to +31 bytes into the line. This AND effectively does a HL DIV 32
	LD L,A		;so we know HL points to the start of the line
	JP snextline

draw_screen:

;draws top 11 rows of map row by row (top)
;draws middle row (1 line)
;draws bottom 11 rows of map row by row (bottom)
;prints X/Y co-ords on top row
;draws plane on middle row

;map's top left corner is set by (xref),(yref) 16-bit values

	EXX
	LD DE,$5820	;part on screen to draw
	EXX
	LD HL,(xref)	;column
	LD B,H
	LD C,L		;transfer to BC
	LD HL,(yref)	;row
	LD A,$0B	;11 lines for top half
	LD (rowcount),A

drw1:
	PUSH BC
	PUSH HL
	CALL dorow	;draw one line on the screen
	POP HL
	POP BC
	INC HL
	LD A,(rowcount)
	DEC A
	LD (rowcount),A
	JP NZ,drw1	;repeat until rowcount has reached 0

;now draw middle row which is where plane is
	PUSH BC
	PUSH HL
	CALL dorow
	POP HL
	POP BC
	INC HL

;and now correct attributes for plane
	LD A,($5990)	;get current attr of plane location
	AND $F8		;keep all but ink
	OR $07		;white ink
	LD ($5990),A	;set attr of plane

;now do other 11 lines
	LD A,$0B
	LD (rowcount),A
drw2:
	PUSH BC
	PUSH HL
	CALL dorow
	POP HL
	POP BC
	INC HL
	LD A,(rowcount)
	DEC A
	LD (rowcount),A
	JP NZ,drw2

;print co-ords on top row

	LD HL,(xref)
	XOR A
	LD (scrnx),A	;PRINT AT 0,0
	LD (scrny),A
	CALL printhex	;print X column
	LD HL,(yref)
	LD A,$1C
	LD (scrnx),A	;PRINT AT 0,28
	CALL printhex	;print y row

;now draw plane
;effectively a print UDG routine
	
	LD DE,UDG_base-$08
	LD A,(planedir)
	LD L,A
	LD H,$00
	ADD HL,HL
	ADD HL,HL
	ADD HL,HL
	ADD HL,DE
	EX DE,HL	;DE now points to character to draw plane
	LD HL,$4890
	LD B,$08

drw3:
	LD A,(DE)	;draw plane UDG
	LD (HL),A
	INC H
	INC DE
	DJNZ drw3

	RET


dorow:

	LD DE,row_base	;base of row table
	ADD HL,HL	;2 bytes per entry
	ADD HL,DE	;index into it
	LD E,(HL)
	INC HL
	LD D,(HL)	;get start of row into DE
	LD H,B
	LD L,C		;column to HL instead of BC
	EXX
	LD C,$00	;location counter (places) set to high value so no false place printed
	EXX
	
p1:
	LD A,(DE)	;get attr value from row entry
	INC DE
	CP $FC		;is it a town (FF), island (FE) or lake (FD)?
	JP NC,getplace	;jump if so
	LD B,A		;store A temporarily
	LD A,(DE)	;now get repeat count byte
	INC DE
	LD C,A		;BC = repeat byte
	LD A,B		;restore A
	LD B,$00	;ensure BC<256

	AND A	
	SBC HL,BC
	JR Z,p2		;if=0 then NC, but reached right column
	JP NC,p1	;not reached required column yet

p2:
;HL now negative!

	LD C,A		;store A
	LD A,L
	NEG		;convert HL (-ve)
	LD B,A		;into B (+ve) ie: FFFA to 06
	INC B		;inc as we need to include when column=00
	LD HL,$0020	;32 bytes to draw
	LD A,C		;restore A
	JP p4		;JP faster than JR

p3:
;B is zero now, so get next entry
	LD A,(DE)	;get new data value
	INC DE
	LD C,A		;preserve it
	LD A,(DE)	;get byte count
	INC DE
	LD B,A
	LD A,C		

p4:
	EXX
	DEC C		;decrease C'
	CALL Z,showplace	;if =0 then this is a placeholder!
	LD (DE),A
	INC DE
	EXX
	DEC HL
	LD A,H		;need 31 more bytes after start
	CP L	
	RET Z		;done row if HL down to 0
	LD A,C		;restore A
	DEC B
	JP NZ,p4	;keep going until byte count=0
	JP p3		;still short so get next pair of values
	
getplace:
;column in HL
	PUSH HL		;preserve it!
	PUSH AF		;preserve type (ie: place or river)
	LD B,H		;transfer HL to BC
	LD C,L
	LD A,(DE)
	LD L,A
	INC DE
	LD A,(DE)
	LD H,A		;that value now in HL
	INC DE

;example
;current col = 10 (BC)
;place = 20 (HL)

	AND A
	SBC HL,BC

;if currcol > Place then no good - CF set

	JR C,place_notin

;now diff has to be <32 for it to work

	LD A,$1F
	CP L

	JR C,place_notin	;CF set if gap is >31
	LD A,H
	CP $00
	JR NZ,place_notin	;in case we're dealing with MSB >0
	LD A,L		;put L into A
	EXX
	LD C,A		;to put into C'
	INC C		;add 1 to cope when =0
	EXX
	LD A,(DE)
	LD L,A
	INC DE
	LD A,(DE)
	LD H,A
	INC DE		;HL now contains pointer to string
	LD (locptr),HL	;preserve it for later
	POP AF
	LD (placetype),A	;preserve type of location for later
	POP HL
	JP p1

place_notin:
	POP AF		;restore AF (place type)
	POP HL		;restore HL
	INC DE
	INC DE		;skip pointer to name of place
	JP p1		;back to dorow


showplace:
;note ALTERNATE REGISTER SET is paged in at this point!

	LD (locscrnptr),DE	;store attr pointer to convert to AT X,Y coords later
	EXX		;back to normal
	PUSH HL		;preserve registers
	PUSH DE
	PUSH BC
	LD DE,$5800
	LD HL,(locscrnptr)
	AND A		;clear CF
	SBC HL,DE	;subtract base so we can do DIV 32 later to get Y, MOD32 for X
	LD A,L
	AND $1F		;MOD32 to get X
	LD (scrnx),A			
	SRL H
	RR L
	SRL H
	RR L
	SRL H
	RR L
	SRL H
	RR L
	SRL H
	RR L		;DIV32 to get Y
	LD A,L
	LD (scrny),A
	LD HL,(locptr)
sh2:
	LD A,(HL)
	BIT 7,A
	JR NZ,sh3	;bit 7 set means last char
	PUSH HL		;preserve HL
	CALL printchar
	POP HL		;restore HL
	INC HL
	JP sh2
sh3:
	AND $7F
	CALL printchar
	POP BC
	POP DE
	POP HL
	EXX		;make sure alternate register set back in
	LD DE,(locscrnptr)	;restore D'E'
	LD A,(placetype)	;what sort of place have we got?
	CP $FF			;FF=town
	JP Z,sh4
	CP $FE		;FE=area
	JR NZ,sh5
	LD A,$C6
	RET
sh5:
	LD A,$A9	;blue on cyan bright to show river/lake name
	RET

sh4:	LD A,$C7	;bright white on black
	RET


printchar:

;print ASCII character in A
;at position in AT (scrny),(scrnx)

	LD B,A		;preserve A
	LD A,(scrny)
	AND $18
	ADD A,$40
	LD H,A
	LD A,(scrny)
	RRCA
	RRCA
	RRCA		;multiply by 32 by shifting right 3 times (same as left 5 times)
	AND $E0
	LD L,A
	LD A,(scrnx)
	CP $20
	RET Z		;skip if already outside screen
	ADD A,L
	LD L,A
	EX DE,HL
	LD L,B
	LD H,$00
	ADD HL,HL
	ADD HL,HL
	ADD HL,HL
	LD A,$3C	;add 3C00 to HL (points to ROM charset)
	ADD A,H
	LD H,A
	LD B,$08
pr2:
	LD A,(HL)
	LD (DE),A
	INC HL
	INC D
	DJNZ pr2
	LD A,(scrnx)
	INC A		;increase column pointer
	LD (scrnx),A
	RET

printhex:
;take HL and print it as hex
	LD A,H
	CALL hexbyte
	LD A,L
	JP hexbyte	;RETurn via hexbyte routine

hexbyte:
	PUSH AF
	AND $F0
	RRCA
	RRCA
	RRCA
	RRCA
	CP $0A
	JR C,hex2
	ADD A,$07
hex2:	ADD A,$30
	PUSH HL
	CALL printchar
	POP HL
	POP AF
	AND $0F
	CP $0A
	JR C,hex3
	ADD A,$07
hex3:	ADD A,$30
	PUSH HL
	CALL printchar
	POP HL
	RET

rowcount DEFW $0000
xref	DEFW $0000
yref	DEFW $0000
planedir DEFB $00
delay	DEFB $00
locptr	DEFW $0000
locscrnptr	DEFW $0000
scrnx	DEFB $00
scrny	DEFB $00
placetype DEFB $00

;UDGs
UDG_base:
;planeE
	DB $00,$00,$80,$98,$FE,$FF,$18,$10
;planeW
	DB $00,$00,$01,$19,$7F,$FF,$18,$08
;speed indicator (would've been planeEW (not used))
	DB $FE,$FE,$FE,$FE,$FE,$FE,$FE,$00
;planeS
	DB $18,$18,$7E,$3C,$18,$18,$18,$18
;planeSE
	DB $C8,$F8,$78,$78,$FC,$0E,$07,$03
;planeSW
	DB $13,$1F,$1E,$1E,$3F,$70,$E0,$C0
;planeSEW (not used)
	DB $00,$00,$00,$00,$00,$00,$00,$00
;planeN
	DB $18,$18,$18,$18,$3C,$7E,$18,$18
;planeNE
	DB $03,$07,$0E,$FC,$78,$78,$F8,$C8
;planeNW
	DB $C0,$E0,$70,$3F,$1E,$1E,$1F,$13

powerbar_attr:
	DB $00,$00,$00,$00
	DB $00,$00,$00,$00
	DB $01,$41,$03,$43,$05,$45,$07,$47,$D6
;last attr byte is for 'turbo' mode!

#END
